package nl.kallestruik.darena.arenas

import nl.kallestruik.darena.arenas.world.ArenaWorld
import nl.kallestruik.darena.util.ArenaUtil
import org.bukkit.plugin.java.JavaPlugin
import org.bukkit.potion.PotionEffect
import org.bukkit.potion.PotionEffectType

class Arena(
    private val config: ArenaConfig,
    private val arenaUtil: ArenaUtil,
    private val plugin: JavaPlugin,
    private val world: ArenaWorld = ArenaWorld(config.name, plugin),
) {
    private lateinit var session: ArenaSession
    // Simple stuff done: 0.001474s
    // createArena start: 0.0001026s
    // Loaded schematic: 0.000162s
    // Created new world: 3.122034s
    // Loaded world: 0.0075989s
    // Placed arena: 2.3205267s
    // Fixed light: 4.2093585s
    // createArena done: 0.0002953
    // Countdown done: 5.0126158
    // Fully done: 0.0982557

    fun start() {
        //TODO: Redo everything in here.
        // Create a new session
        session = ArenaSession()
        // Add all participants and spectators
        session.participants.addAll(arenaUtil.getPossibleParticipants());
        session.spectators.addAll(arenaUtil.getPossibleSpectators());
        // Reset the world
        world.reset()



        // Place all spectators in the arena
        session.spectators.forEach {
//            config.spectatorSpawn.spawn(world, it)
        }

        // Randomize spawns
        session.initialSpawns.addAll(config.spawns.filter {
                                         //TODO: make this filter only spawns that meet the intitial spawn condidtions. Or just replace this whole method.
                                         return@filter true
                                     }.keys)
        session.initialSpawns.shuffle()

        // Spawn all the players
        session.participants.forEachIndexed { index, player ->
            // TODO: Freeze players in place (for in arena countdown) (if countdown is 0 dont freeze them)
            config.spawns[session.initialSpawns[index % session.initialSpawns.size]]!!.spawn(world, player)
        }
        // TODO:
    }

    fun reset() {
        world.reset()
    }
}
