package nl.kallestruik.darena.types.arena

import org.bukkit.configuration.ConfigurationSection
import nl.kallestruik.darena.types.ConfigSaveable
import nl.kallestruik.darena.types.ConfigLoadable

data class ArenaLocation(
    val x: Int,
    val y: Int,
    val z: Int
): ConfigSaveable {
    override fun save(section: ConfigurationSection) {
        section.set("x", x)
        section.set("y", y)
        section.set("z", z)
    }

    companion object: ConfigLoadable<ArenaLocation> {
        override fun load(section: ConfigurationSection): ArenaLocation {
            return ArenaLocation(
                section.getInt("x", 0),
                section.getInt("y", 0),
                section.getInt("z", 0),
            )
        }
    }
}
