package nl.kallestruik.darena.types.arena

import org.bukkit.configuration.ConfigurationSection
import nl.kallestruik.darena.util.ConfigHelper

data class ArenaPoints(
    val kill: List<Int> = listOf(0),
    val lastManStanding: List<Int> = listOf(0),
    val checkpoints: Map<String, List<Int>> = mapOf()
) {
    fun save(section: ConfigurationSection) {
        section.set("kill", ConfigHelper.intListToString(kill))
        section.set("lastManStanding", ConfigHelper.intListToString(lastManStanding))

        val checkpointSection = ConfigHelper.getOrCreateSection(section, "checkpoints")
        for (entry in checkpoints) {
            checkpointSection.set(entry.key, ConfigHelper.intListToString(entry.value))
        }

    }

    companion object {
        fun load(section: ConfigurationSection): ArenaPoints {
            return ArenaPoints(
                ConfigHelper.parseIntList(section.getString("kill")!!),
                ConfigHelper.parseIntList(section.getString("lastManStanding")!!),
                ConfigHelper.parseStringIntListMap(section.getConfigurationSection("checkpoints")!!)
            )
        }
    }
}
