package nl.kallestruik.darena.types.arena

import nl.kallestruik.darena.types.ConfigLoadable
import nl.kallestruik.darena.types.ConfigSaveable
import nl.kallestruik.darena.util.ConfigHelper
import org.bukkit.configuration.ConfigurationSection

class ArenaSpawnRule(
    val reuseSpawns: Boolean,
    val effects: Map<String, ArenaPotionEffect>,
    val spawns: List<String>
): ConfigSaveable {
    override fun save(section: ConfigurationSection) {
        section.set("reuseSpawns", reuseSpawns)
        ConfigHelper.saveMap(ConfigHelper.getOrCreateSection(section, "effects"), effects)
        section.set("spawns", spawns)
    }

    companion object: ConfigLoadable<ArenaSpawnRule> {
        override fun load(section: ConfigurationSection): ArenaSpawnRule {
            return ArenaSpawnRule(
                section.getBoolean("reuseSpawn", true),
                ConfigHelper.loadMap(section.getConfigurationSection("effects")!!, ArenaPotionEffect),
                section.getStringList("spawns"))
        }
    }
}
